## A collection of my Penetration Testing Tools, Scripts, Cheatsheets

This is a collection of more than a **160+** tools, scripts, cheatsheets and other loots that I've been developing over years for Penetration Testing and IT Security audits purposes. 
Most of them came handy at least once during my real-world engagements.

**Notice:** In order to clone this repository properly - use `--recurse-submodules` switch:
```
git clone --recurse https://github.com/mgeeky/Penetration-Testing-Tools.git
```

Most of these files were initially shared on my [Gists](https://gist.github.com/mgeeky) but eventually got moved into this repository.

Every time I stumbled upon a problem that could be better scripted or resolved programatically - I made effort to do just that and thus improve my technical assurance capabilities or to optimize time spent on repetitive actions during projects I've been delivering. 

The collection is divided further onto following sections:

- `clouds` - Tools I came up with during my cloud assessments
- `file-formats` - file-format related utilities, fuzzers and alike.
- `linux` - small bunch of Linux-based scripts and tools.
- `networks` - Network devices & protocols Penetration Testing toolery
- `others` - Others related somehow to this craftmanship
- `phishing` - Scripts and tools used to deliver Phishing Awareness and Red Team simulations 
- `red-teaming` - Lots of toolings I've been using during my Purple/Red-Teaming engagements
- `web` - Web applications security assessment related utilities.
- `windows` - Windows goodies, scripts, exploits.

The base of these tools do not contain any customer/client related sensitive information as well as there are no engagement-specific tools developed as PoCs.

---

### ☕ Show Support ☕

This and other projects are outcome of sleepless nights and **plenty of hard work**. If you like what I do and appreciate that I always give back to the community,
[Consider buying me a coffee](https://github.com/sponsors/mgeeky) _(or better a beer)_ just to say thank you! 💪 

---

```
Mariusz Banach / mgeeky, (@mariuszbit)
<mb [at] binary-offensive.com>
```